//
// ======== SocketInput.java ========
//
// generated by GenModule.java
//
 
/**
 * This class creates a thread which listens on a socket.  When a connection is
 * established, the listen thread is stopped, and the update method passes bytes
 * read to the output stream.
 *
 * @version    1.0, Thu Apr 04 08:10:23  1996
 * @author     Johannes N. Johannsen, jojo@well.com
 */
import java.io.*;
import java.net.*;
public class SocketInput extends InputDevice {
 
   /**
    * Streams access by user names below, or vectors declared in NeatToolsModule.
    */
   NeatInputStream socketNumber;
   NeatOutputStream out_byteStream;
 
   /**
    * Non-stream custom fields.
    */
   ServerSocket listener;
   Socket listenSocket;
   InputStream socketInputStream;
 
 
   /**
    * Constructor for SocketInput
    */
   public SocketInput() {
      super();
      socketNumber = new FixedIntStream( 0 );
      inputStreams.addElement( socketNumber );
      out_byteStream = new NeatOutputStream( IOstream.BYTE );
      outputStreams.addElement( out_byteStream );
   }
 
 
   /**
    * Generated function startUp*
    */
   public void startUp() {
      if ( !running ) {
         try {
            listener = new ServerSocket( socketNumber.getInt() );
            listenSocket = listener.accept();
            socketInputStream = listenSocket.getInputStream();
            running = true;
         } catch ( java.io.IOException e ) {
            System.out.println( "Exception listening on socket " + socketNumber.getInt() );
         }
      }
   }
 
 
   /**
    * Generated function shutDown*
    */
   public void shutDown() {
      if ( running ) {
      }
   }
 
 
   /**
    * Generated function reset*
    */
   public void reset() {
      // does nothing
   }
 
 
   /**
    * Generated function update*
    */
   public void update() {
      if ( running ) {
         if ( out_byteStream.dataAvailable ) {
            try {
               if ( socketInputStream.available() > 0 ) {
                  byte b = (byte)socketInputStream.read();
                  out_byteStream.setByte( b );
               }
            } catch ( java.io.IOException e ) {
               System.out.println( "SocketInput exception checking if data available" );
            }
         }
      }
   }
}
